'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _redisApi = require('./redisApi');

var _meta = require('./meta');

var _meta2 = _interopRequireDefault(_meta);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var hgetCommand = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2, key, field) {
    var client = _ref2.client,
        meta = _ref2.meta;
    var result;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _redisApi.hget)(client, key, field);

          case 2:
            result = _context.sent;
            return _context.abrupt('return', result === undefined ? null : result);

          case 4:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function hgetCommand(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var hsetCommand = function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref4, key, field, value) {
    var client = _ref4.client,
        meta = _ref4.meta,
        lastTimestamp = _ref4.lastTimestamp;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(value === null || value === undefined)) {
              _context2.next = 7;
              break;
            }

            _context2.next = 3;
            return (0, _redisApi.hdel)(client, key, field);

          case 3:
            _context2.next = 5;
            return meta.del(key);

          case 5:
            _context2.next = 14;
            break;

          case 7:
            _context2.next = 9;
            return (0, _redisApi.hset)(client, key, field, value);

          case 9:
            _context2.next = 11;
            return meta.exists(key);

          case 11:
            if (_context2.sent) {
              _context2.next = 14;
              break;
            }

            _context2.next = 14;
            return meta.create(key);

          case 14:
            _context2.next = 16;
            return meta.setLastTimestamp(lastTimestamp);

          case 16:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function hsetCommand(_x4, _x5, _x6, _x7) {
    return _ref3.apply(this, arguments);
  };
}();

var delCommand = function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref6, key) {
    var client = _ref6.client,
        meta = _ref6.meta,
        lastTimestamp = _ref6.lastTimestamp;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, _redisApi.del)(client, key);

          case 2:
            _context3.next = 4;
            return meta.del(key);

          case 4:
            _context3.next = 6;
            return meta.setLastTimestamp(lastTimestamp);

          case 6:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function delCommand(_x8, _x9) {
    return _ref5.apply(this, arguments);
  };
}();

var adapter = function () {
  var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(repository) {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return (0, _meta2.default)(repository);

          case 2:
            repository.meta = _context4.sent;
            return _context4.abrupt('return', Object.freeze({
              hget: hgetCommand.bind(null, repository),
              hset: hsetCommand.bind(null, repository),
              del: delCommand.bind(null, repository)
            }));

          case 4:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function adapter(_x10) {
    return _ref7.apply(this, arguments);
  };
}();

exports.default = adapter;
module.exports = exports['default'];