'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('regenerator-runtime/runtime');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var buildProjection = function buildProjection(repository, inputProjection) {
  return Object.keys(inputProjection).reduce(function (projection, eventType) {
    if (eventType === 'Init' && typeof inputProjection[eventType] === 'function') {
      repository.initHandler = inputProjection[eventType];
      return projection;
    }

    projection[eventType] = function () {
      var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(event, onDemandOptions) {
        var writeInterface, handler;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return repository.initDonePromise;

              case 2:
                writeInterface = repository.writeInterface;
                handler = inputProjection[eventType];

                repository.lastTimestamp = event.timestamp;

                _context.prev = 5;
                _context.next = 8;
                return handler(writeInterface, event);

              case 8:
                _context.next = 13;
                break;

              case 10:
                _context.prev = 10;
                _context.t0 = _context['catch'](5);

                repository.internalError = _context.t0;

              case 13:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, undefined, [[5, 10]]);
      }));

      return function (_x, _x2) {
        return _ref.apply(this, arguments);
      };
    }();
    return projection;
  }, {});
};

exports.default = buildProjection;
module.exports = exports['default'];