'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _adapter = require('./adapter');

var _adapter2 = _interopRequireDefault(_adapter);

var _storeInterface = require('./storeInterface');

var _storeInterface2 = _interopRequireDefault(_storeInterface);

var _messages = require('./messages');

var _messages2 = _interopRequireDefault(_messages);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var initProjection = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(repository) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return repository.connectionPromise;

          case 2:
            if (!(repository.lastTimestamp !== 0)) {
              _context.next = 4;
              break;
            }

            return _context.abrupt('return');

          case 4:
            repository.lastTimestamp = 1;

            _context.prev = 5;
            _context.next = 8;
            return repository.initHandler(repository.writeInterface);

          case 8:
            _context.next = 13;
            break;

          case 10:
            _context.prev = 10;
            _context.t0 = _context['catch'](5);

            repository.internalError = _context.t0;

          case 13:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined, [[5, 10]]);
  }));

  return function initProjection(_x) {
    return _ref.apply(this, arguments);
  };
}();

var synchronizeDatabase = function () {
  var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(repository, client) {
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.t0 = Math;
            _context2.t1 = repository.lastTimestamp;
            _context2.next = 4;
            return repository.meta.getLastTimestamp();

          case 4:
            _context2.t2 = _context2.sent;
            repository.lastTimestamp = _context2.t0.max.call(_context2.t0, _context2.t1, _context2.t2);

          case 6:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function synchronizeDatabase(_x2, _x3) {
    return _ref2.apply(this, arguments);
  };
}();

var init = function init(repository) {
  if (repository.interfaceMap) {
    throw new Error(_messages2.default.alreadyInitialized);
  }
  repository.lastTimestamp = 0;

  if (typeof repository.initHandler !== 'function') {
    repository.initHandler = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
      return regeneratorRuntime.wrap(function _callee3$(_context3) {
        while (1) {
          switch (_context3.prev = _context3.next) {
            case 0:
            case 'end':
              return _context3.stop();
          }
        }
      }, _callee3, undefined);
    }));
  }

  repository.connectionPromise = repository.connectDatabase().then(function (client) {
    return repository.client = client;
  }).then(_asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return (0, _adapter2.default)(repository);

          case 2:
            repository.nativeAdapter = _context4.sent;

          case 3:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }))).then(synchronizeDatabase.bind(null, repository));

  repository.internalError = null;

  repository.readInterface = (0, _storeInterface2.default)(repository, false);
  repository.writeInterface = (0, _storeInterface2.default)(repository, true);

  repository.initDonePromise = initProjection(repository);

  return {
    getLastAppliedTimestamp: function () {
      var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                _context5.next = 2;
                return repository.connectionPromise;

              case 2:
                return _context5.abrupt('return', repository.lastTimestamp);

              case 3:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, undefined);
      }));

      return function getLastAppliedTimestamp() {
        return _ref5.apply(this, arguments);
      };
    }(),
    getReadable: function () {
      var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6() {
        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return repository.initDonePromise;

              case 2:
                return _context6.abrupt('return', repository.readInterface);

              case 3:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, undefined);
      }));

      return function getReadable() {
        return _ref6.apply(this, arguments);
      };
    }(),
    getError: function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _context7.next = 2;
                return repository.initDonePromise;

              case 2:
                return _context7.abrupt('return', repository.internalError);

              case 3:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, undefined);
      }));

      return function getError() {
        return _ref7.apply(this, arguments);
      };
    }()
  };
};

exports.default = init;
module.exports = exports['default'];