'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _redisApi = require('./redisApi');

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var DEFAULT_META = {};

var create = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2, cache, newName) {
    var client = _ref2.client,
        metaName = _ref2.metaName,
        lastTimestampKey = _ref2.lastTimestampKey;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _redisApi.hset)(client, metaName, newName, DEFAULT_META);

          case 2:
            cache[newName] = true;

          case 3:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function create(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var del = function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref4, cache, key) {
    var client = _ref4.client,
        metaName = _ref4.metaName,
        lastTimestampKey = _ref4.lastTimestampKey;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return (0, _redisApi.hdel)(client, metaName, key);

          case 2:
            delete cache[key];

          case 3:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function del(_x4, _x5, _x6) {
    return _ref3.apply(this, arguments);
  };
}();

var getLastTimestamp = function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref6) {
    var client = _ref6.client,
        metaName = _ref6.metaName,
        lastTimestampKey = _ref6.lastTimestampKey;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return (0, _redisApi.hget)(client, metaName, lastTimestampKey);

          case 2:
            return _context3.abrupt('return', _context3.sent);

          case 3:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function getLastTimestamp(_x7) {
    return _ref5.apply(this, arguments);
  };
}();

var setLastTimestamp = function () {
  var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(_ref8, lastTimestamp) {
    var client = _ref8.client,
        metaName = _ref8.metaName,
        lastTimestampKey = _ref8.lastTimestampKey;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            _context4.next = 2;
            return (0, _redisApi.hset)(client, metaName, lastTimestampKey, lastTimestamp);

          case 2:
          case 'end':
            return _context4.stop();
        }
      }
    }, _callee4, undefined);
  }));

  return function setLastTimestamp(_x8, _x9) {
    return _ref7.apply(this, arguments);
  };
}();

var getKeys = function () {
  var _ref9 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(_ref10) {
    var client = _ref10.client,
        metaName = _ref10.metaName;
    var result;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return (0, _redisApi.hkeys)(client, metaName);

          case 2:
            result = _context5.sent;
            return _context5.abrupt('return', result ? result : {});

          case 4:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, undefined);
  }));

  return function getKeys(_x10) {
    return _ref9.apply(this, arguments);
  };
}();

exports.default = function () {
  var _ref11 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee8(repository) {
    var cache;
    return regeneratorRuntime.wrap(function _callee8$(_context8) {
      while (1) {
        switch (_context8.prev = _context8.next) {
          case 0:
            _context8.next = 2;
            return getKeys(repository);

          case 2:
            cache = _context8.sent;
            return _context8.abrupt('return', Object.freeze({
              create: create.bind(null, repository, cache),
              del: del.bind(null, repository, cache),
              exists: function () {
                var _ref12 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(name) {
                  return regeneratorRuntime.wrap(function _callee6$(_context6) {
                    while (1) {
                      switch (_context6.prev = _context6.next) {
                        case 0:
                          return _context6.abrupt('return', !!cache[name]);

                        case 1:
                        case 'end':
                          return _context6.stop();
                      }
                    }
                  }, _callee6, undefined);
                }));

                return function exists(_x12) {
                  return _ref12.apply(this, arguments);
                };
              }(),
              getLastTimestamp: getLastTimestamp.bind(null, repository),
              setLastTimestamp: setLastTimestamp.bind(null, repository),
              list: function () {
                var _ref13 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7() {
                  return regeneratorRuntime.wrap(function _callee7$(_context7) {
                    while (1) {
                      switch (_context7.prev = _context7.next) {
                        case 0:
                          return _context7.abrupt('return', Object.keys(cache));

                        case 1:
                        case 'end':
                          return _context7.stop();
                      }
                    }
                  }, _callee7, undefined);
                }));

                return function list() {
                  return _ref13.apply(this, arguments);
                };
              }()
            }));

          case 4:
          case 'end':
            return _context8.stop();
        }
      }
    }, _callee8, undefined);
  }));

  return function (_x11) {
    return _ref11.apply(this, arguments);
  };
}();

module.exports = exports['default'];