'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

require('regenerator-runtime/runtime');

var _redisApi = require('./redisApi');

var _adapter = require('./adapter');

var _adapter2 = _interopRequireDefault(_adapter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var disposeDatabase = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref2, client) {
    var metaName = _ref2.metaName,
        lastTimestampKey = _ref2.lastTimestampKey;
    var tempRepository, adapter, meta, names, promises;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            tempRepository = {
              metaName: metaName,
              lastTimestampKey: lastTimestampKey,
              client: client
            };
            _context2.next = 3;
            return (0, _adapter2.default)(tempRepository);

          case 3:
            adapter = _context2.sent;
            meta = tempRepository.meta;
            _context2.next = 7;
            return meta.list();

          case 7:
            names = _context2.sent;
            promises = names.map(function () {
              var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(name) {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _context.next = 2;
                        return adapter.del(name);

                      case 2:
                      case 'end':
                        return _context.stop();
                    }
                  }
                }, _callee, undefined);
              }));

              return function (_x3) {
                return _ref3.apply(this, arguments);
              };
            }());
            _context2.next = 11;
            return Promise.all(promises);

          case 11:
            _context2.t0 = Promise;
            _context2.next = 14;
            return (0, _redisApi.del)(client, metaName);

          case 14:
            _context2.t1 = _context2.sent;
            _context2.next = 17;
            return (0, _redisApi.del)(client, lastTimestampKey);

          case 17:
            _context2.t2 = _context2.sent;
            _context2.t3 = [_context2.t1, _context2.t2];
            _context2.next = 21;
            return _context2.t0.all.call(_context2.t0, _context2.t3);

          case 21:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function disposeDatabase(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var reset = function reset(repository) {
  if (repository.disposePromise) {
    return repository.disposePromise;
  }

  var client = repository.client,
      metaName = repository.metaName,
      lastTimestampKey = repository.lastTimestampKey;


  var disposePromise = repository.connectionPromise.then(disposeDatabase.bind(null, {
    metaName: metaName,
    lastTimestampKey: lastTimestampKey
  }, client));

  Object.keys(repository).forEach(function (key) {
    delete repository[key];
  });

  repository.disposePromise = disposePromise;
  return disposePromise;
};

exports.default = reset;
module.exports = exports['default'];