'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _messages = require('./messages');

var _messages2 = _interopRequireDefault(_messages);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var hget = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(_ref2, key, field) {
    var nativeAdapter = _ref2.nativeAdapter,
        connectionPromise = _ref2.connectionPromise;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return connectionPromise;

          case 2:
            _context.next = 4;
            return nativeAdapter.hget(key, field);

          case 4:
            return _context.abrupt('return', _context.sent);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function hget(_x, _x2, _x3) {
    return _ref.apply(this, arguments);
  };
}();

var hset = function () {
  var _ref3 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(_ref4, key, field, value) {
    var nativeAdapter = _ref4.nativeAdapter,
        connectionPromise = _ref4.connectionPromise;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return connectionPromise;

          case 2:
            _context2.next = 4;
            return nativeAdapter.hset(key, field, value);

          case 4:
            return _context2.abrupt('return', _context2.sent);

          case 5:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function hset(_x4, _x5, _x6, _x7) {
    return _ref3.apply(this, arguments);
  };
}();

var del = function () {
  var _ref5 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(_ref6, key) {
    var nativeAdapter = _ref6.nativeAdapter,
        connectionPromise = _ref6.connectionPromise;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _context3.next = 2;
            return connectionPromise;

          case 2:
            _context3.next = 4;
            return nativeAdapter.del(key);

          case 4:
            return _context3.abrupt('return', _context3.sent);

          case 5:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function del(_x8, _x9) {
    return _ref5.apply(this, arguments);
  };
}();

var getStoreInterface = function getStoreInterface(repository, isWriteable) {
  if (isWriteable) {
    return Object.freeze({
      hget: hget.bind(null, repository),
      hset: hset.bind(null, repository),
      del: del.bind(null, repository)
    });
  }

  return Object.freeze({
    hget: hget.bind(null, repository),
    hset: function () {
      var _ref7 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                throw new Error(_messages2.default.readSideForbiddenOperation('hset'));

              case 1:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, undefined);
      }));

      return function hset() {
        return _ref7.apply(this, arguments);
      };
    }(),
    del: function () {
      var _ref8 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                throw new Error(_messages2.default.readSideForbiddenOperation('del'));

              case 1:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, undefined);
      }));

      return function del() {
        return _ref8.apply(this, arguments);
      };
    }()
  });
};

exports.default = getStoreInterface;
module.exports = exports['default'];